Subject: RE: [AAA-WG]: Diameter messages vs. SCTP packets

From: <[email-masked]>
Date: Tue, 17 Dec 2002 07:07:32 +0200

Hi Adrian,

> The base specification and the transport profile do not 
> mandate anything about how the Diameter messages are 
> encapsulated in the SCTP packets. 

This is dependent upon the SCTP implementation.
Many SCTP implementations will be using sockets,
see: http://www.ietf.org/internet-drafts/draft-ietf-tsvwg-sctpsocket-05.txt
for details. 

> This means that a Diameter 
> implementation must be prepared to receive all possible 
> combinations, e.g. one Diameter message sent in multiple SCTP 
> packets or 1.5 Diameter messages in one SCTP packets.
> 
> The receiver would be greatly simplified if one of the 
> specifications requires that a SCTP packet contains a 
> non-fractional number of Diameter messages.

SCTP will present a fully formed Diameter packet to the Diameter
level, this will be no different than with TCP.

There is nothing more that is needed in Base or transport document
more that is needed.

John

---

From: <[email-masked]>
Date: Tue, 17 Dec 2002 07:15:27 +0200

Hi,

One more note - SCTP supports user data up to 64k.  I hope that Diameter messages are not
that long ....

> -----Original Message-----
> From: ext [mailto:[email-masked]]
> Sent: 16 December, 2002 19:17
> To: [email-masked]
> Subject: [AAA-WG]: Diameter messages vs. SCTP packets
> 
> 
> Hi,
> 
> encapsulated in the SCTP packets. This means that a Diameter 
> Regards,
> Adrian

---

From: <[email-masked]>
Date: Tue, 17 Dec 2002 10:43:06 +0200

Adrian,

One further comment.  SCTP provides fragmentation & re-assembly services
for the upper layer protocol.  From 2960:

  1.3.3 User Data Fragmentation

     When needed, SCTP fragments user messages to ensure that the SCTP
     packet passed to the lower layer conforms to the path MTU.  On
     receipt, fragments are reassembled into complete messages before
     being passed to the SCTP user.

So I don't think we need to worry about your concerns.

More interesting SCTP reading can be found here (disclaimer - I am a 
co-auther of 3257).

Stream Control Transmission Protocol Applicability Statement (RFC 3257) 
http://www.ietf.org/rfc/rfc3257.txt

br,
John

---

From: [email-masked]
Date: Tue, 17 Dec 2002 14:29:11 +0530

Hi

section 6.9 of 2960 says

"Note: If the data receiver runs out of buffer space while still   waiting for
more fragments to complete the re-assembly of the   message, it should dispatch
part of its inbound message through a   partial delivery API (see Section 10),
freeing some of its receive   buffer space so that the rest of the message may
be received."

section 3.1.4 of draft-ietf-tsvwg-sctpsocket-05.txt says:

"If the SCTP stack is running low on buffers, it may partially deliver   a
message.  In this case, MSG_EOR will not be set, and more calls to   recvmsg()
will be necessary to completely consume the message.  Only   one message at a
time can be partially delivered."

Doesn't it mean that one Diameter message may arrive in multiple SCTP packets to
the Diameter implementation?

Regards
-Ankit

[email-masked] on 12/17/2002 02:13:06 PM

To:   [email-masked], [email-masked]
cc:    (bcc: Ankit Bansal/HSS)

Subject:  RE: [AAA-WG]: Diameter messages vs. SCTP packets

Adrian,

br,
John

---

From: <[email-masked]>
Date: Tue, 17 Dec 2002 11:23:33 +0200

Hi Ankit,

These are implementation issues.  Partial Delivery is a MAY, meaning
one cannot assume that it is implemented.  

How large will Diameter messages be?  I don't expect them to be
very large ..

John

> From: ext [email-masked] [mailto:[email-masked]]
> Sent: 17 December, 2002 10:59
> To: [email-masked]

---

From: <[email-masked]>
Date: Tue, 17 Dec 2002 11:45:28 +0200

Hi Ankit,

Even if Diameter messages arrive in multiple packets, how does it require any change to the Diameter specicication. Is this not an implementation issue?

- Kishore

-----Original Message-----
From: ext [email-masked] [mailto:[email-masked]]
Sent: 17. December 2002 10:59
To: [email-masked]
Subject: RE: [AAA-WG]: Diameter messages vs. SCTP packets

Hi

section 6.9 of 2960 says

Regards
-Ankit

Adrian,

br,
John

---

From: [email-masked]
Date: Tue, 17 Dec 2002 15:18:51 +0530

Hi Kishore

I am not saying that it is not an implementation issue. Its just there is an
exception to the statement from 2960 :

  1.3.3 User Data Fragmentation
     On receipt, fragments are reassembled into complete messages before
     being passed to the SCTP user.

The Diameter implementation will have to block till it has received the entire
message if it spans multiple SCTP packets.

-Ankit

[email-masked] on 12/17/2002 03:15:28 PM

To:   Ankit Bansal/HSS@HSS, [email-masked]
cc:

Hi Ankit,

Even if Diameter messages arrive in multiple packets, how does it require any
change to the Diameter specicication. Is this not an implementation issue?

- Kishore

-----Original Message-----
From: ext [email-masked] [mailto:[email-masked]]
Sent: 17. December 2002 10:59
To: [email-masked]
Subject: RE: [AAA-WG]: Diameter messages vs. SCTP packets

Hi

section 6.9 of 2960 says

Regards
-Ankit

Adrian,

br,
John